/*************************************************************************\
|* example2.c -- Example application for the Nettool Library             *|
|* (c)1997 Project INSANITY Software.  By: Steve Conley                  *|
\*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "nettool.h"

/* Parse input fron connections */
int parser(char* input,CON* who);

/* Actual connection handling loop */
int conloop(INPCON* master_con);

/* Only one arguement expected -- port */
int main(int argc,char* argv[]){
	INPCON* connection; /* Here's the master connection */
	int     port;       /* Store the port temp-like here */

	if(argc > 2){ /* Too many arguements? */
		printf("Syntax: %s [port]\n",argv[0]);
		return(0);
	}
	if(argc==2){ /* Port arguement? */
		if(!isdigit(*argv[1])){ /* Not a digit? */
			printf("Syntax: %s [port]\n",argv[0]);
			return(0);
		}
		port=atoi(argv[1]); /* Get the port number */
	}else{
		port=9900; /* Otherwise use the default */
	}
	connection=inpcon_init(port); /* Inialize the connection */
	return(conloop(connection)); /* Run the main loop */
}

/* Loop through and handle new connections */
int conloop(INPCON* master_con){
	CON*  ptr;    /* Various temporary variables */
	CON*  ptr2;
	int   done=0;
	char  buf[50];
	char* input;

	while(!done){ /* While we're not done ... */
		if(inpcon_accept(master_con)){ /* Accept new connections */
			ptr2=master_con->head; /* If there's a new connection, */
			while(ptr2!=NULL){     /* tell everyone */
				consend(ptr2,"Someone else has connected.\n");
				ptr2=ptr2->next;
			}
		}
		ptr=master_con->head; /* Start to scan the linked list */
		while(ptr!=NULL){
			done=parser(input=conrecv(ptr),ptr); /* Parse input */
			if(done==-1){ /* If someone's disconnecting */
				ptr2=ptr;
				ptr=ptr->next;
				disconnect(master_con,ptr2); /* Disconnect them */
				ptr2=master_con->head; /* Tell everyone */
				while(ptr2!=NULL){
					consend(ptr2,"Someone else has disconnected.\n");
					ptr2=ptr2->next;
				}
				done=0;
				ptr=master_con->head;
			}else if(done==-2){ /* If someone's talking */
				ptr2=master_con->head; /* Tell everyone */
				sprintf(buf,"Descr. %i> ",ptr->descr);
				while(ptr2!=NULL){
					consend(ptr2,buf);
					consend(ptr2,input);
					ptr2=ptr2->next;
				}
				done=0;
				ptr=ptr->next;
			}else{ /* Otherwise, go on down the list */
				ptr=ptr->next;
			}
		}
	}
	INPdestroy(master_con); /* Kill the connection */
}

/* This is a basic parser and doesn't do anything snappy really */
int parser(char* input,CON* who){
	if(input==NULL){
		return(0);
	}
	if(!strncmp(input,"QUIT",4)){
		return(-1);
	}
	if(!strncmp(input,"help",4)){
		consend(who,"QUIT disconnects you, SHUTDOWN kills the server.  Anything else is displayed to all connected.\n");
		return(0);
	}
	if(!strncmp(input,"SHUTDOWN",8)){
		return(1);
	}
	return(-2);
}
